//////////////////////////////////////////////
// Repeater									//
// Created by Jaydee						//
// Damage: 20/bullet						//
// Spread: 0.0025							//
//////////////////////////////////////////////

//Repeater Firing Sound
datablock AudioProfile(repeaterShotSound)
{
   filename    = "./repeater_fire.wav";
   description = AudioClose3d;
   preload = true;
};

//Bullet hit sounds
datablock AudioProfile(impact1HitSound)
{
   filename    = "./impact1.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(impact2HitSound)
{
   filename    = "./impact2.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(impact3HitSound)
{
   filename    = "./impact3.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(RepeaterFireParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 40;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

	colors[0]     = "0.9 0.9 0 0.3";
	colors[1]     = "1 0.5 0.2 0.5";
	colors[2]     = "1 0.5 0.2 0.0";

	sizes[0]      = 1.15;
   sizes[1]      = 0.84;
	sizes[2]      = 0.12;

   times[0] = 0.0;
   times[1] = 0.1;
   times[2] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(RepeaterFireEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 48.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 1;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RepeaterFireParticle";
};

//Repeater trail
datablock ParticleData(RepeaterTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 100;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "1 1 1 0.2";
	colors[1]	= "1 0.75 0.05 0.1";
	colors[2]	= "1 0.75 0.05 0.0";
	sizes[0]	= 0.35;
	sizes[1]	= 0.15;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.5;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(RepeaterTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = RepeaterTrailParticle;
};

//effects
datablock ParticleData(RepeaterStickExplosionParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = 0.1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/chunk";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "1 0.6 0.05 0.9";
	colors[1]     = "1 0.6 0.05 0.0";
	sizes[0]      = 0.33;
	sizes[1]      = 0.0;
};
datablock ParticleEmitterData(RepeaterStickExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 80;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RepeaterStickExplosionParticle";

   useEmitterColors = true;
};

datablock ExplosionData(RepeaterStickExplosion)
{
   //explosionShape = "";
	soundProfile = "";

   lifeTimeMS = 150;

   particleEmitter = RepeaterStickExplosionEmitter;
   particleDensity = 17;
   particleRadius = 0.2;

   emitter[0] = "";

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 1;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};

datablock ParticleData(RepeaterExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.3;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.8 0.8 0.8 0.9";
	colors[1]     = "0.8 0.8 0.8 0.0";
	sizes[0]      = 0.45;
	sizes[1]      = 0.0;

   useInvAlpha = true;
};
datablock ParticleEmitterData(RepeaterExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RepeaterExplosionParticle";

};
datablock ExplosionData(RepeaterExplosion)
{
   //explosionShape = "";
	soundProfile = "";

   lifeTimeMS = 100;

   emitter[0] = RepeaterExplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "3.0 4.0 3.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 1;
   lightStartColor = "1 0.75 0.05";
   lightEndColor = "0 0 0";
};

AddDamageType("Repeater",   '<bitmap:add-ons/Weapon_Repeater/CI_Repeater> %1',    '%2 <bitmap:add-ons/Weapon_Repeater/CI_Repeater> %1',0.2,1);
datablock ProjectileData(RepeaterProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::Repeater;
   radiusDamageType    = $DamageType::Repeater;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 50;
   verticalImpulse	  = 50;
   explosion           = RepeaterExplosion;
   particleEmitter     = RepeaterTrailEmitter; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.85;
   bounceFriction      = 0.10;
   isBallistic         = true;
   gravityMod = 0.0;

   hasLight    = true;
   lightRadius = 1.0;
   lightColor  = "1 0.76 0.05";

   uiName = "Repeater Bullet";
};

//////////
// item //
//////////
datablock ItemData(RepeaterItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./repeater.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Repeater G.";
	iconName = "./icon_Repeater";
	doColorShift = false;
	colorShiftColor = "1 0.75 0.05 1.000";

	 // Dynamic properties defined by the scripts
	image = RepeaterImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(RepeaterImage)
{
   // Basic Item properties
   shapeFile = "./repeater.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = RepeaterItem;
   ammo = " ";
   projectile = RepeaterProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   colorShiftColor = RepeaterItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateTransitionOnTriggerUp[1]     = "Cooldown";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.05;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= RepeaterFireEmitter;
	stateEmitterTime[2]				= 0.2;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= repeaterShotSound;
	stateEjectShell[2]       = true;
	
	//Nonexistant smoke
	stateName[3] = "Smoke";
	//stateEmitter[3]					= RepeaterSmokeEmitter;
	//stateEmitterTime[3]				= 0.05;
	//stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.01;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateTransitionOnTriggerDown[4]     = "Ready";
	stateSequence[4]	= "Ready";
	
	stateName[5] = "Cooldown";
	stateTimeoutValue[5]            = 0.05;
	stateTransitionOnTimeout[5]     = "Ready";
	stateScript[5]                  = "Cooldown";
};

function RepeaterImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, "Fire");
		%obj.playThread(2, Plant);
		
	//New Code that applies dynamic spread depending on how much is your fire rate. 
	//Little ticks give you a more accurate shot, spraying gives the traditional spread.
	
	%projectile = %this.projectile;
	%spread = 0.00075 * (%obj.heat * 0.1);
	%shellcount = 1;
	
	%obj.maxHeat = 20;
	
	if(%obj.heat < %obj.maxHeat)
		%obj.heat += 2;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

//Random impact sounds for lols
function RepeaterProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
{
	Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
	%random = getRandom(1,3);
	switch(%random)
	{
		case 1:
			serverplay3d(impact1HitSound,%pos);
		case 2:
			serverplay3d(impact2HitSound,%pos);
		case 3:
			serverplay3d(impact3HitSound,%pos);
		default:
			echo("Error on Repeater");
	}
}

//Smooth cooldown intended
function RepeaterImage::Cooldown(%this,%obj,%slot)
{
	if (%obj.heat > 0)
	{
	%obj.heat -= %obj.maxHeat*0.1;
	}
}